=begin rdoc
提取者：dota_
版本：1.0
名称：Ｚ轴归零
备注：本插件大部分代码提取自thomthom的建筑工具。本人对代码进行整理及精简及修改，现在插件不需要依靠TT运行库并且支持SU2015。
更新：
		1.0  2015/05/24  ...
=end
require 'sketchup'
class Zto0
	
	def self.main
		model = Sketchup.active_model
		begin
			model.start_operation("Ｚ轴归零", true)
		rescue
			model.start_operation("Ｚ轴归零")
		end
		flatten_entities model.selection
		model.commit_operation
		UI.messagebox '已完成Z轴归零。'
	end
	def self.flatten_entities(ents)
		vertices = []
		ents.each { |e|
			if e.is_a?(Sketchup::ComponentInstance) || e.is_a?(Sketchup::Group)
				flatten_entities definition(e).entities
				p = e.transformation.origin.clone
				p.z = 0
				v = e.transformation.origin.vector_to(p)
				e.transform!( Geom::Transformation.new(v) )
			end
			vertices << e if e.is_a?(Sketchup::ConstructionPoint)
			vertices << e.vertices if e.respond_to?(:vertices)
			e.explode_curve if e.is_a?(Sketchup::Edge)
		}
		vertices.flatten!
		vertices.uniq!
		entities = []
		vectors = []
		point = nil
		vertices.each { |v|
			point = v.position
			next if point.z == 0
			entities << v
			point.z = 0
			vectors << v.position.vector_to(point) 
		}
		if ents.is_a?(Sketchup::Selection)
			ents.model.active_entities.transform_by_vectors(entities, vectors)
		else
			ents.transform_by_vectors(entities, vectors)
		end
	end
	
	def self.definition(instance)
		if instance.respond_to?(:definition)
			return instance.definition
		elsif instance.is_a?(Sketchup::Group)
			if instance.entities.parent.instances.include?(instance)
				return instance.entities.parent
			else
				Sketchup.active_model.definitions.each { |definition|
				return definition if definition.instances.include?(instance)
				}
			end
		end
		return nil
	end
end
    
unless file_loaded?( "Zto0.rb" )
	UI.menu( 'Plugins' ).add_item( 'Ｚ轴归零' ) { 
		if Sketchup.active_model.selection.empty?
			UI.messagebox '未选择对象 !'
		else
			Zto0.main
		end
	}
end
file_loaded( "Zto0.rb" )

    toolbar = UI::Toolbar.new "Ｚ轴归零"
    cmd = UI::Command.new("Ｚ轴归零")  { 
		if Sketchup.active_model.selection.empty?
			UI.messagebox '未选择对象 !'
		else
			Zto0.main
		end
	}
    cmd.tooltip = "Ｚ轴归零"
    cmd.status_bar_text = '可将线条压平到与坐标原点相同高度的同一水平面内，可穿透组。'
    cmd.small_icon = "Zto0/Flatten_16.png"
    cmd.large_icon = "Zto0/Flatten_24.png"
    toolbar = toolbar.add_item cmd
    toolbar.show
    puts cmd.large_icon
